using System;
using System.Web;


namespace AspNetGallery.Extensions.Modules
{
    public class MarkerModule : IHttpModule
    {
        #region Constants
        const String PageHeaderText = "<table width=100% style='font-family:verdana;font-size:8pt;' bgcolor=cyan><tr><td align=center>You must register to continue enjoy this Web site! Click <b><a href=http://www.contoso.com>here</a>.</b></td></tr></table>";
        const String PageFooterText = "<table width=100% style='font-family:verdana;font-size:8pt;' bgcolor=cyan><tr><td align=center>Courtesy of <b>Programming Microsoft ASP.NET 4</b></td></tr></table>";
		#endregion


        #region IHttpModule
        public void Init(HttpApplication app)
        {
            // Register for pipeline events
            app.BeginRequest += OnBeginRequest;
            app.EndRequest += OnEndRequest;
        }

        public void Dispose()
        {
            // Nothing to do here
        }
        #endregion


        #region Helpers
        public void OnBeginRequest(Object sender, EventArgs e)
        {
            var app = (HttpApplication) sender;
            var ctx = app.Context;

		    // More code here
            if (!ShouldHook(ctx))
                return;

            // Add custom header to the HTTP response
            ctx.Response.AppendHeader("Author", "DinoE");
            ctx.Response.Write(PageHeaderText);
        }

        public void OnEndRequest(Object sender, EventArgs e)
        {
            var app = (HttpApplication) sender;
            var ctx = app.Context;

            // More code here
            if (!ShouldHook(ctx))
                return;
        		
            // Append some custom text
            ctx.Response.Write(PageFooterText);
        }

        public Boolean ShouldHook(HttpContext ctx)
        {
            return ctx.Request.Path.EndsWith("markerdemo.aspx", StringComparison.OrdinalIgnoreCase);
        }
        #endregion
    }
}
