﻿/**
 *   Central repository object for this page: default.aspx.
 */
var DEFAULT_ASPX = {};

/**
*   Central repository object for this page: default.aspx.
*/
DEFAULT_ASPX.GridViewSelector = "MainContent_GridView1";
DEFAULT_ASPX.ProductCellSelector = "span.clickable";
DEFAULT_ASPX.InternalAttribute = "Tag";

/**
*   Page initializer: performs all tasks required to set up this page.
*/
DEFAULT_ASPX.initialize = function () {
    // Adds a click handler to all SPAN tags within the first grid column
    var items = $(DEFAULT_ASPX.GridViewSelector).querySelectorAll(DEFAULT_ASPX.ProductCellSelector);
    for (var i = 0; i < items.length; i++) {
        var elem = items[i];
        GLOBALS.addHandler(elem, "click", DEFAULT_ASPX.selectProduct);
    };
};

/**
*   Handles user clicking on cells in the first column 
*
*   @param  {Object}  e     Event object as returned by the browser
*/
DEFAULT_ASPX.selectProduct = function (e) {
    var target = GLOBALS.getSrcElement(e);
    var productId = target.getAttribute(DEFAULT_ASPX.InternalAttribute);

    DEFAULT_ASPX.process(productId);
}

/**
*   Processes the selected product 
*
*   @param  {Number}  productId     ID of the product the user clicked on
*/
DEFAULT_ASPX.process = function (productId) {
    window.alert(productId);
}



// Trigger page initialization
GLOBALS.setPageInitializer(DEFAULT_ASPX.initialize);


 