﻿using System;
using System.Web;

namespace MyAjax
{
    public class Service : IHttpHandler
    {
        public void ProcessRequest(HttpContext context)
        {
            // Method name
            var method = context.Request.PathInfo;
            method = method.TrimStart(new [] {'/', '\\'});

            // Execution
            var results = ExecuteMethodInternal(method); 
            
            // Results
            context.Response.ContentType = "text/plain";
            context.Response.Write(results);
        }

        public bool IsReusable
        {
            get
            {
                return false;
            }
        }

        private object ExecuteMethodInternal(String methodName)
        {
 	        var t = GetType();
            var methodInfo = t.GetMethod(methodName);
            if (methodInfo == null)
                return "No method found.";

            var o = methodInfo.Invoke(this, null);
            return o;
        }

        public object GetNextEmployeeId()
        {
            var rnd = new Random();
            return rnd.Next(1, 100);
        }
    }
}