﻿using System;
using System.Drawing;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;


namespace ControlFun
{
    public partial class StyleFun : Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            var myAreaStyle = new Style {ForeColor = Color.Blue, BackColor = Color.LightGray};

            // Add the style to the to the <style> section of the header (for the current page)
            Page.Header.StyleSheet.CreateStyleRule(myAreaStyle, null, "DIV#MyArea");

            // Add a .aspnet_sXXX class to the <style> section of the header (for the current page)   XXX is a progressive number
            Page.Header.StyleSheet.RegisterStyle(myAreaStyle, null);

            Label1.ApplyStyle(myAreaStyle);
            Label2.MergeStyle(myAreaStyle);

            // Meta information
            var meta1 = new HtmlMeta {Name = "keywords", Content = "Key terms that describe your page"};
            Page.Header.Controls.Add(meta1);

            // Link CSS files
            var link = new HtmlLink {Href = "~/StyleSheet.css"};
            link.Attributes.Add("rel", "stylesheet");
            link.Attributes.Add("type", "text/css");
            Page.Header.Controls.Add(link);
        }
    }
}