﻿using System;
using System.Collections.Generic;
using System.Linq;

namespace Grid.DAL
{
    public class CustomerRepository
    {
        public IList<String> GetCountries()
        {
            var context = new NorthwindEntities();
            var query = (from c in context.Customers select c.Country).Distinct();
            return query.ToList();
        }

        public IList<Customer> GetCustomersByCountry(String country)
        {
            if (country.Contains(","))
                return GetCustomersByCountryMultiple(country);

            var context = new NorthwindEntities();
            var query = from c in context.Customers 
                        where c.Country.Equals(country, StringComparison.InvariantCultureIgnoreCase) 
                        select c;
            return query.ToList();
        }

        protected IList<Customer> GetCustomersByCountryMultiple(String countries)
        {
            var context = new NorthwindEntities();
            var query = from c in context.Customers
                        where countries.Contains(c.Country)
                        select c;
            return query.ToList();
        }

        public IList<Object> GetCitiesWithCustomers(String country)
        {
            var context = new NorthwindEntities();
            var query = (from c in context.Customers 
                         where c.Country == country 
                         select new {c.City, c.Country}).Distinct();
            return query.ToArray();
        }
    }
}