﻿using System;
using System.Web.UI;
using Simple.DAL;

namespace Simple
{
    public partial class Templates : Page
    {
        private Int32 _citiesCount;

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
                FillCountries();
        }

        protected void FillCountries()
        {
            var repo = new CustomerRepository();
            var data = repo.GetCountries();

            Countries.DataSource = data;
            Countries.DataBind();
        }

        protected int CalcTotal()
        {
            return _citiesCount; 
        }

        protected void Countries_SelectedIndexChanged(object sender, EventArgs e)
        {
            var country = Countries.SelectedValue;

            var repo = new CustomerRepository();
            var data = repo.GetCitiesWithCustomers(country);
            _citiesCount = data.Count;

            Repeater1.DataSource = data;
            Repeater1.DataBind();
        }
    }
}