﻿using System;
using System.Windows;
using Mvvm.ExternalServices;
using Mvvm.Helpers;
using Mvvm.Model;
using Mvvm.ViewModel;

namespace Mvvm
{
    public partial class MainPage  
    {
        public MainPage()
        {
            InitializeComponent();
        }

        private InventoryViewModel ViewModel
        {
            get { return (InventoryViewModel)DataContext; }
        }

        private void linkSearchNow_Click(object sender, RoutedEventArgs e)
        {
            var isSearchByName = ViewModel.IsSearchByName;

            var proxy = new InventoryManagerClient();
            if (isSearchByName)
            {
                proxy.GetInventoryByNameCompleted += proxy_GetInventoryByNameCompleted; 
                proxy.GetInventoryByNameAsync(ViewModel.UserText); 
            }
            else
            {
                proxy.GetInventoryByIdCompleted += proxy_GetInventoryByIdCompleted;
                proxy.GetInventoryByIdAsync(ViewModel.UserText.ToInt32());
            }
        }

        void proxy_GetInventoryByIdCompleted(Object sender, GetInventoryByIdCompletedEventArgs e)
        {
            ResetDisplay();
            ViewModel.Product = ProductInfoForDisplay.Import(e.Result);
        }

        void proxy_GetInventoryByNameCompleted(Object sender, GetInventoryByNameCompletedEventArgs e) 
        { 
            ResetDisplay();
            ViewModel.Products = ProductListForDisplay.Import(e.Result);
        }

        private void radioSearchById_Click(object sender, RoutedEventArgs e)
        {
            if (!ViewModel.IsEmptyInput)
                ViewModel.IsProductPanelVisible = true;
        }

        private void radioSearchByName_Click(object sender, RoutedEventArgs e)
        {
            ViewModel.IsProductPanelVisible = false;
        }

        private void ResetDisplay()
        {

            if (!ViewModel.IsEmptyInput)
            {
                if (this.ViewModel.IsSearchById)
                {
                    ViewModel.IsProductPanelVisible = true;
                    ViewModel.IsProductListPanelVisible = false;
                }
                else
                {
                    ViewModel.IsProductPanelVisible = false;
                    ViewModel.IsProductListPanelVisible = true;
                }
            }
            else
            {
                ViewModel.IsProductPanelVisible = false;
                ViewModel.IsProductListPanelVisible = false;
            }
        }
    }
}
