﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;

namespace SilverRia.Web.Services
{
    public class InventoryManager : IInventoryManager
    {
        public ProductInfo GetInventoryById(Int32 id) 
        { 
            var context = new AdventureWorksDataContext();
            var product = (from p in context.Products
                           where p.ProductID == id
                           select new ProductInfo
                                      {
                                          ProductId = p.ProductID,
                                          Name = p.Name,
                                          ProductNumber = p.ProductNumber,
                                          ReorderPoint = p.ReorderPoint,
                                          SafetyStockLevel = p.SafetyStockLevel
                                      }).FirstOrDefault();
            if (product == null)
                return new MissingProductInfo(); //new ProductInfo(); 

            return product; 
        }

        public IList<ProductInfo> GetInventoryByName(String name)
        {
            var testValue = name.ToLower();
            var context = new AdventureWorksDataContext();
            var products = (from p in context.Products
                            where p.Name.ToLower().Contains(testValue)
                            select new ProductInfo
                                       {
                                           ProductId = p.ProductID,
                                           Name = p.Name,
                                           ProductNumber = p.ProductNumber,
                                           ReorderPoint = p.ReorderPoint,
                                           SafetyStockLevel = p.SafetyStockLevel
                                       }).ToList();
            return products; 
        }
    }
}
