using System;
using System.Linq;
using Entities;
using LiveQuoteManager.Services;

namespace LiveQuoteManager
{
    public class LiveQuoteInternalService
    {
        #region ILiveQuotes Members

        public StockInfo[] GetQuotes(String symbols)
        {
            // Dependency #1--quote provider
            var quoteProvider = ServiceLocator.GetService<IQuoteProvider>() as IQuoteProvider;
            if (quoteProvider == null)
                throw new NullReferenceException("Finance data provider not found.");

            // Dependency #2--quote formatter
            //var quoteFormatter = ServiceLocator.GetService<IQuoteFormatter>() as IQuoteFormatter;
            //if (quoteFormatter == null)
            //    throw new NullReferenceException("Finance data formatter not found.");

            // Work and return results
            return quoteProvider.GetQuotes(symbols).ToArray();
        }

        #endregion
    }


}