﻿using System;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace CustomAuth.Account
{
    public partial class Login : Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            RegisterHyperLink.NavigateUrl = "Register.aspx?ReturnUrl=" + HttpUtility.UrlEncode(Request.QueryString["ReturnUrl"]);
        }

        protected override bool OnBubbleEvent(object source, EventArgs args)
        {
            return false;
        }

        protected void LoginUser_Authenticate(object sender, AuthenticateEventArgs e)
        {
            // Perform some validation
            var userName = LoginUser.UserName;
            var password = LoginUser.Password;
            var isAuthenticated = true;

            // Create the (default) authentication cookie
            //FormsAuthentication.SetAuthCookie(userName, createPersistentCookie);


            // Create the (custom) authentication cookie: current time and a random number
            var createPersistentCookie = true;
            var number = new Random().Next(0, 100);
            var customInfo = String.Format("{0}|{1}", DateTime.Now, number);

            // Create and encrypt the ticket
            var ticket = new FormsAuthenticationTicket(
                3,                             // Version number
                userName,                      // Username
                DateTime.Now,                  // Issue date
                DateTime.Now.AddMinutes(30),   // Expiration date
                createPersistentCookie,        // Is it persistent?
                customInfo                     // User data
            );
            var encTicket = FormsAuthentication.Encrypt(ticket);

            // Store the ticket into a cookie
            var cookie = FormsAuthentication.GetAuthCookie(
                                FormsAuthentication.FormsCookieName,
                                createPersistentCookie);
            cookie.Value = encTicket;

            // Append the cookie to the response and redirect
            HttpContext.Current.Response.Cookies.Add(cookie);
            Response.Redirect(FormsAuthentication.DefaultUrl);
        }

        protected void LoginUser_LoggedIn(object sender, EventArgs e)
        {

        }
    }
}
