﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Script.Serialization;

namespace AutoComplete
{
    class JqueryUiBindingModel
    {
        public String value { get; set; }
        public Int32 id { get; set; }
    }

    public class PlayersAutoComplete : IHttpHandler
    {

        public void ProcessRequest(HttpContext context)
        {
            // This is the prefix the user typed in
            var prefix = context.Request["term"].ToLower();

            // This will be replaced by a plain SQL query
            var allPlayers = new List<JqueryUiBindingModel>
                              {
                                  new JqueryUiBindingModel {value="Federer, Roger", id=1},
                                  new JqueryUiBindingModel {value="Nadal, Rafael", id=2},
                                  new JqueryUiBindingModel {value="Djokovic, Novak", id=3},
                                  new JqueryUiBindingModel {value="Ferrer, David", id=4},
                                  new JqueryUiBindingModel {value="Soderling, Robin", id=5},
                                  new JqueryUiBindingModel {value="Stakhovsky, Sergey", id=6},
                                  new JqueryUiBindingModel {value="Dolgopolov, Yuri", id=7},
                                  new JqueryUiBindingModel {value="Ferrero, Juan Carlos", id=8},
                                  new JqueryUiBindingModel {value="Murray, Andy", id=9},
                                  new JqueryUiBindingModel {value="Montanes, Albert", id=10}
                              };

            var players = (from p in allPlayers where p.value.ToLower().StartsWith(prefix) select p).ToList();
            
            // Step 1: Run the query and get a data reader
            // Step 2: Create a list of JqueryUiBindingModel objects
            //   var players = new List<JqueryUiBindingModel>();
            // Step 3: Loop over the data reader and create a new JqueryUiBindingModel object
            //   var p = new JqueryUiBindingModel();
            //   p.Name = reader["..."];
            //   p.Id = reader["..."];
            //   players.Add(p);

            
            // Save the list to JSON
            var serializer = new JavaScriptSerializer();
            var json = serializer.Serialize(players);
            
            context.Response.ContentType = "application/json";
            context.Response.Write(json);
        }

        public bool IsReusable
        {
            get { return true; }
        }
    }
}