﻿using System;
using System.Web;
using System.Web.Script.Serialization;
using JsonP.Model;

namespace JsonP.Handlers
{
    public class Service1 : IHttpHandler
    {
        public void ProcessRequest(HttpContext context)
        {
            var methodName = context.Request.PathInfo.Trim('/');
            var methodInfo = GetType().GetMethod(methodName);
            if (methodInfo == null)
                return;
            var result = methodInfo.Invoke(this, null);


            // Assume the function name is part of your service's SDK. Default it to "handleData"
            var serializer = new JavaScriptSerializer();
            var output = String.Format("handleData({0})", serializer.Serialize(result));

            context.Response.ContentType = "application/json";
            context.Response.Write(output);
        }

        // Change this to emulate Web services
        // URL to call this: /service1.ashx/GetCustomer
        public Customer GetCustomer()
        {
            var customer = new Customer() { Id = 1000, CompanyName = "Crionet" };
            return customer;   
        }

        // Add other public methods


        public bool IsReusable
        {
            get { return false; }
        }
    }
}